<%--
 ~
 ~ Copyright (c) 2021, WSO2 Inc. (http://www.wso2.com). All Rights Reserved.
 ~
 ~ This software is the property of WSO2 Inc. and its suppliers, if any.
 ~ Dissemination of any information or reproduction of any material contained
 ~ herein in any form is strictly forbidden, unless permitted by WSO2 expressly.
 ~ You may not alter or remove any copyright or other notice from copies of this content."
 ~
--%>

<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>
<%@ page import="com.google.gson.Gson" %>
<%@ page import="org.wso2.carbon.identity.application.authentication.endpoint.util.AuthContextAPIClient" %>
<%@ page import="org.wso2.carbon.identity.application.authentication.endpoint.util.Constants" %>
<%@ page import="org.wso2.carbon.identity.core.util.IdentityCoreConstants" %>
<%@ page import="org.wso2.carbon.identity.core.util.IdentityUtil" %>
<%@ page import="static org.wso2.carbon.identity.application.authentication.endpoint.util.Constants.STATUS" %>
<%@ page import="static org.wso2.carbon.identity.application.authentication.endpoint.util.Constants.STATUS_MSG" %>
<%@ page import="static org.wso2.carbon.identity.application.authentication.endpoint.util.Constants.CONFIGURATION_ERROR" %>
<%@ page import="static org.wso2.carbon.identity.application.authentication.endpoint.util.Constants.AUTHENTICATION_MECHANISM_NOT_CONFIGURED" %>
<%@ page import="static org.wso2.carbon.identity.application.authentication.endpoint.util.Constants.ENABLE_AUTHENTICATION_WITH_REST_API" %>
<%@ page import="static org.wso2.carbon.identity.application.authentication.endpoint.util.Constants.ERROR_WHILE_BUILDING_THE_ACCOUNT_RECOVERY_ENDPOINT_URL" %>
<%@ page import="org.wso2.carbon.identity.captcha.util.CaptchaUtil" %>
<%@ page import="org.wso2.carbon.identity.mgt.endpoint.util.IdentityManagementEndpointConstants" %>
<%@ page import="org.wso2.carbon.identity.mgt.endpoint.util.client.IdentityProviderDataRetrievalClient" %>
<%@ page import="org.wso2.carbon.identity.mgt.endpoint.util.client.IdentityProviderDataRetrievalClientException" %>
<%@ page import="java.io.File" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.Arrays" %>
<%@ page import="java.util.Map" %>
<%@ page import="org.owasp.encoder.Encode" %>

<%@ include file="includes/localize.jsp" %>

<!-- Include tenant context -->
<jsp:directive.include file="includes/init-url.jsp"/>

<!-- Branding Preferences -->
<jsp:directive.include file="extensions/branding-preferences.jsp"/>

<%!
    private static final String FIDO_AUTHENTICATOR = "FIDOAuthenticator";
    private static final String MAGIC_LINK_AUTHENTICATOR = "MagicLinkAuthenticator";
    private static final String IWA_AUTHENTICATOR = "IwaNTLMAuthenticator";
    private static final String IS_SAAS_APP = "isSaaSApp";
    private static final String BASIC_AUTHENTICATOR = "BasicAuthenticator";
    private static final String IDENTIFIER_EXECUTOR = "IdentifierExecutor";
    private static final String OPEN_ID_AUTHENTICATOR = "OpenIDAuthenticator";
    private static final String JWT_BASIC_AUTHENTICATOR = "JWTBasicAuthenticator";
    private static final String X509_CERTIFICATE_AUTHENTICATOR = "x509CertificateAuthenticator";
    private static final String GOOGLE_AUTHENTICATOR = "GoogleOIDCAuthenticator";
    private static final String GITHUB_AUTHENTICATOR = "GithubAuthenticator";
    private static final String FACEBOOK_AUTHENTICATOR = "FacebookAuthenticator";
    private static final String OIDC_AUTHENTICATOR = "OpenIDConnectAuthenticator";
    private static final String MICROSOFT_IDP = "Microsoft";
%>

<%
    String promptAccountLinking = "";
    request.getSession().invalidate();
    String queryString = request.getQueryString();
    Map<String, String> idpAuthenticatorMapping = null;
    if (request.getAttribute(Constants.IDP_AUTHENTICATOR_MAP) != null) {
        idpAuthenticatorMapping = (Map<String, String>) request.getAttribute(Constants.IDP_AUTHENTICATOR_MAP);
    }

    String errorMessage = "authentication.failed.please.retry";
    String errorCode = "";
    if(request.getParameter(Constants.ERROR_CODE)!=null){
        errorCode = request.getParameter(Constants.ERROR_CODE) ;
    }
    String loginFailed = "false";

    if (Boolean.parseBoolean(request.getParameter(Constants.AUTH_FAILURE))) {
        loginFailed = "true";
        String error = request.getParameter(Constants.AUTH_FAILURE_MSG);
        // Check the error is not null and whether there is a corresponding value in the resource bundle.
        if (!(StringUtils.isBlank(error)) &&
                !error.equalsIgnoreCase(AuthenticationEndpointUtil.i18n(resourceBundle, error))) {
            errorMessage = error;
        }
    }
%>
<%
    boolean hasLocalLoginOptions = false;
    boolean isBackChannelBasicAuth = false;
    List<String> localAuthenticatorNames = new ArrayList<String>();

    if (idpAuthenticatorMapping != null && idpAuthenticatorMapping.get(Constants.RESIDENT_IDP_RESERVED_NAME) != null) {
        String authList = idpAuthenticatorMapping.get(Constants.RESIDENT_IDP_RESERVED_NAME);
        if (authList != null) {
            localAuthenticatorNames = Arrays.asList(authList.split(","));
        }
    }

    String multiOptionURIParam = "";
    if (localAuthenticatorNames.size() > 1 || idpAuthenticatorMapping != null && idpAuthenticatorMapping.size() > 1) {
        String baseURL;
        try {
            baseURL = ServiceURLBuilder.create().addPath(request.getRequestURI()).build().getRelativePublicURL();
        } catch (URLBuilderException e) {
            request.setAttribute(STATUS, AuthenticationEndpointUtil.i18n(resourceBundle, "internal.error.occurred"));
            request.setAttribute(STATUS_MSG, AuthenticationEndpointUtil.i18n(resourceBundle, "error.when.processing.authentication.request"));
            request.getRequestDispatcher("error.do").forward(request, response);
            return;
        }

        String queryParamString = request.getQueryString() != null ? ("?" + request.getQueryString()) : "";
        multiOptionURIParam = "&multiOptionURI=" + Encode.forUriComponent(baseURL + queryParamString);
    }
%>
<%
    boolean reCaptchaEnabled = false;
    if (request.getParameter("reCaptcha") != null && Boolean.parseBoolean(request.getParameter("reCaptcha"))) {
        reCaptchaEnabled = true;
    }

    boolean reCaptchaResendEnabled = false;
    if (request.getParameter("reCaptchaResend") != null && Boolean.parseBoolean(request.getParameter("reCaptchaResend"))) {
        reCaptchaResendEnabled = true;
    }
%>
<%
    String inputType = request.getParameter("inputType");
    String username = null;
    String usernameIdentifier = null;

    if (isIdentifierFirstLogin(inputType)) {
        String authAPIURL = application.getInitParameter(Constants.AUTHENTICATION_REST_ENDPOINT_URL);
        if (StringUtils.isBlank(authAPIURL)) {
            authAPIURL = IdentityUtil.getServerURL("/api/identity/auth/v1.1/", true, true);
        }
        if (!authAPIURL.endsWith("/")) {
            authAPIURL += "/";
        }
        authAPIURL += "context/" + request.getParameter("sessionDataKey");
        String contextProperties = AuthContextAPIClient.getContextProperties(authAPIURL);
        Gson gson = new Gson();
        Map<String, Object> parameters = gson.fromJson(contextProperties, Map.class);
        if (parameters != null) {
            username = (String) parameters.get("username");
            usernameIdentifier = (String) parameters.get("username");
            promptAccountLinking = (String) parameters.get("prompt_for_account_linking");
        } else {
            String redirectURL = "error.do";
            response.sendRedirect(redirectURL);
            return;
        }
    }

    // Login context request url.
    String sessionDataKey = Encode.forUriComponent(request.getParameter("sessionDataKey"));
    String appName = Encode.forUriComponent(request.getParameter("sp"));
    String loginContextRequestUrl = logincontextURL + "?sessionDataKey=" + sessionDataKey + "&application="
            + appName;
    if (!IdentityTenantUtil.isTenantQualifiedUrlsEnabled()) {
        // We need to send the tenant domain as a query param only in non tenant qualified URL mode.
        loginContextRequestUrl += "&tenantDomain=" + tenantDomain;
    }

    String t = request.getParameter("t");
    String ut = request.getParameter("ut");
    if (StringUtils.isNotBlank(t)) {
        loginContextRequestUrl += "&t=" + t;
    }
    if (StringUtils.isNotBlank(ut)) {
        loginContextRequestUrl += "&ut=" + ut;
    }

    if (StringUtils.isNotBlank(usernameIdentifier)) {
        if (usernameIdentifier.split("@").length == 2) {
            usernameIdentifier = usernameIdentifier.split("@")[0];
        }

        if (usernameIdentifier.split("@").length > 2
            && !StringUtils.equals(usernameIdentifier.split("@")[1], IdentityManagementEndpointConstants.SUPER_TENANT)) {

            usernameIdentifier = usernameIdentifier.split("@")[0] + "@" + usernameIdentifier.split("@")[1];
        }
    }
%>


<!doctype html>
<html>
<head>
    <!-- header -->
    <%
        File headerFile = new File(getServletContext().getRealPath("extensions/header.jsp"));
        if (headerFile.exists()) {
    %>
        <jsp:include page="extensions/header.jsp"/>
    <% } else { %>
        <jsp:include page="includes/header.jsp"/>
    <% } %>

    <%
        if (reCaptchaEnabled || reCaptchaResendEnabled) {
    %>
    <script src="https://www.google.com/recaptcha/api.js" async defer></script>
    <%
        }
    %>
</head>
<body class="login-portal layout authentication-portal-layout" onload="checkSessionKey()">

    <% request.setAttribute("pageName", "sign-in"); %>
    <% if (new File(getServletContext().getRealPath("extensions/timeout.jsp")).exists()) { %>
        <jsp:include page="extensions/timeout.jsp"/>
    <% } else { %>
        <jsp:include page="util/timeout.jsp"/>
    <% } %>

    <%
        if (StringUtils.equals(tenantForTheming, IdentityManagementEndpointConstants.SUPER_TENANT) && !StringUtils
        .equals("true", promptAccountLinking)) {
    %>
        <div class="page-wrapper right-aligned">
            <main class="center-segment">
                <jsp:include page="extensions/product-tagline.jsp"/>
    <%
        } else {
    %>
        <div class="page-wrapper">
            <main class="center-segment">
    <% } %>

    <%
        String insightsAppIdentifier = request.getParameter("client_id");
        String insightsTenantIdentifier = userTenant;

        if (!Boolean.parseBoolean(request.getParameter(IS_SAAS_APP))) {
            insightsAppIdentifier = "business-app";
        }
        else if (!StringUtils.isEmpty(insightsAppIdentifier)) {
            insightsAppIdentifier = StringUtils.lowerCase(insightsAppIdentifier).replace("_", "-");
        }
     %>

            <div class="ui container medium center aligned middle aligned">
                <%
                    if (StringUtils.equals(tenantForTheming, IdentityManagementEndpointConstants.SUPER_TENANT) &&
                    StringUtils.equals("true", promptAccountLinking)) {
                %>
                        <div class="theme-icon inline auto transparent product-logo portal-logo">
                            <img src="libs/themes/asgardio/assets/images/branding/asgardeo-logo.svg" alt="Asgardeo Logo" />
                        </div>
                <% } %>
                <!-- product-title -->
                <%
                    File productTitleFile = new File(getServletContext().getRealPath("extensions/product-title.jsp"));
                    if (productTitleFile.exists()) {
                %>
                    <%
                        if (StringUtils.equals(tenantForTheming, IdentityManagementEndpointConstants.SUPER_TENANT)) {
                    %>
                        <div class="product-title">
                            <jsp:include page="extensions/product-title.jsp"/>
                        </div>
                    <% } else { %>
                        <jsp:include page="extensions/product-title.jsp"/>
                    <% } %>
                <% } else { %>
                    <jsp:include page="includes/product-title.jsp"/>
                <% } %>

                <div class="ui segment">
                    <h3 class="ui header">
                        <%  if (Boolean.parseBoolean(promptAccountLinking)) { %>
                            <%=AuthenticationEndpointUtil.i18n(resourceBundle, "account.linking") %>
                        <% } else if (isIdentifierFirstLogin(inputType)) { %>
                            <%=AuthenticationEndpointUtil.i18n(resourceBundle, "welcome") %>
                        <% } else { %>
                            <%=AuthenticationEndpointUtil.i18n(resourceBundle, "login")%>
                        <% } %>
                    </h3>

                    <%  if (Boolean.parseBoolean(promptAccountLinking)) { %>
                        <p class="account-linking ui-label">
                            <%=AuthenticationEndpointUtil.i18n(resourceBundle, "account.linking.proceed") %>
                        </p>
                    <% } %>

                    <% if (isIdentifierFirstLogin(inputType)) { %>
                    <div class="identifier-container">
                        <img class="ui image mr-1"
                             alt="Username Icon"
                             src="libs/themes/asgardio/assets/images/user.svg">
                        <span id="user-name-label"
                              class="ellipsis"
                              data-position="top left"
                              data-variation="inverted"
                              data-content="<%=usernameIdentifier%>">
                            <%=usernameIdentifier%>
                        </span>
                    </div>
                    <% } %>

                    <div class="segment-form">
                        <%
                            if (localAuthenticatorNames.size() > 0) {
                                if (localAuthenticatorNames.contains(OPEN_ID_AUTHENTICATOR)) {
                                    hasLocalLoginOptions = true;
                        %>
                            <%@ include file="openid.jsp" %>
                        <%
                            } else if (localAuthenticatorNames.contains(IDENTIFIER_EXECUTOR)) {
                                hasLocalLoginOptions = true;
                        %>
                            <%@ include file="identifierauth.jsp" %>
                        <%
                            } else if (localAuthenticatorNames.contains(JWT_BASIC_AUTHENTICATOR) ||
                                localAuthenticatorNames.contains(BASIC_AUTHENTICATOR)) {
                                hasLocalLoginOptions = true;
                                boolean includeBasicAuth = true;
                                if (localAuthenticatorNames.contains(JWT_BASIC_AUTHENTICATOR)) {
                                    if (Boolean.parseBoolean(application.getInitParameter(ENABLE_AUTHENTICATION_WITH_REST_API))) {
                                        isBackChannelBasicAuth = true;
                                    } else {
                                        String redirectURL = "error.do?" + STATUS + "=" + CONFIGURATION_ERROR + "&" +
                                                STATUS_MSG + "=" + AUTHENTICATION_MECHANISM_NOT_CONFIGURED;
                                        response.sendRedirect(redirectURL);
                                        return;
                                    }
                                } else if (localAuthenticatorNames.contains(BASIC_AUTHENTICATOR)) {
                                    isBackChannelBasicAuth = false;
                                if (TenantDataManager.isTenantListEnabled() && Boolean.parseBoolean(request.getParameter(IS_SAAS_APP))) {
                                    includeBasicAuth = false;
                        %>
                                    <%@ include file="tenantauth.jsp" %>
                        <%
                                }
                            }

                                    if (includeBasicAuth) {
                                        %>
                                            <%@ include file="basicauth.jsp" %>
                                        <%
                                    }
                                }
                            }
                        %>
                        <%if (idpAuthenticatorMapping != null &&
                                idpAuthenticatorMapping.get(Constants.RESIDENT_IDP_RESERVED_NAME) != null) { %>

                        <%} %>
                        <%
                            if ((hasLocalLoginOptions && localAuthenticatorNames.size() > 1) || (!hasLocalLoginOptions)
                                    || (hasLocalLoginOptions && idpAuthenticatorMapping != null && idpAuthenticatorMapping.size() > 1)) {
                        %>
                        <% if (localAuthenticatorNames.contains(BASIC_AUTHENTICATOR) ||
                                localAuthenticatorNames.contains(IDENTIFIER_EXECUTOR)) { %>
                        <div class="ui horizontal divider">
                            Or
                        </div>
                        <% } %>
                        <div class="field">
                            <div class="ui vertical ui center aligned segment form">
                                <%
                                    int iconId = 0;
                                    if (idpAuthenticatorMapping != null) {
                                    for (Map.Entry<String, String> idpEntry : idpAuthenticatorMapping.entrySet()) {
                                        iconId++;
                                        if (!idpEntry.getKey().equals(Constants.RESIDENT_IDP_RESERVED_NAME)) {
                                            String idpName = idpEntry.getKey();
                                            String idpDisplayName = idpName;

                                            boolean isHubIdp = false;
                                            boolean isGoogleIdp = false;
                                            boolean isGitHubIdp = false;
                                            boolean isFacebookIdp = false;
                                            boolean isMicrosoftIdp = false;

                                            if (idpName.endsWith(".hub")) {
                                                isHubIdp = true;
                                                idpName = idpName.substring(0, idpName.length() - 4);
                                            }
                                            if (StringUtils.equals(idpEntry.getValue(),GOOGLE_AUTHENTICATOR)) {
                                                isGoogleIdp = true;
                                            }
                                            if (StringUtils.equals(idpEntry.getValue(),GITHUB_AUTHENTICATOR)) {
                                                isGitHubIdp = true;
                                            }
                                            if (StringUtils.equals(idpEntry.getValue(), FACEBOOK_AUTHENTICATOR)) {
                                                isFacebookIdp = true;
                                            }
                                            if (StringUtils.equals(idpEntry.getValue(), OIDC_AUTHENTICATOR)) {
                                                if (StringUtils.equals(idpName, MICROSOFT_IDP)) {
                                                    isMicrosoftIdp = true;
                                                }
                                            }

                                            // Uses the `IdentityProviderDataRetrievalClient` to get the IDP image.
                                            // TODO: Use this approach for Google, GitHub etc. since it's not scalable.
                                            // Might Need to fix E2E suite as well.
                                            String imageURL = "libs/themes/asgardio/assets/images/identity-providers/enterprise-idp-illustration.svg";

                                            try {
                                                IdentityProviderDataRetrievalClient identityProviderDataRetrievalClient = new IdentityProviderDataRetrievalClient();
                                                imageURL = identityProviderDataRetrievalClient.getIdPImage(tenantDomain, idpName);
                                            } catch (IdentityProviderDataRetrievalClientException e) {
                                                // Exception is ignored and the default `imageURL` value will be used as a fallback.
                                            }

                                            // If any IdP's name starts with `Sign in with`, then we need to remove the `Sign in with` part.
                                            // If not, the UI will look weird with labels like `Sign in with Sign In With Google`.
                                            String EXTERNAL_CONNECTION_PREFIX = "sign in with";

                                            if (StringUtils.startsWithIgnoreCase(idpDisplayName, EXTERNAL_CONNECTION_PREFIX)) {
                                                idpDisplayName = idpDisplayName.substring(EXTERNAL_CONNECTION_PREFIX.length());
                                            }
                                %>
                                    <% if (isHubIdp) { %>
                                        <div class="field">
                                            <button class="ui labeled icon button fluid isHubIdpPopupButton" id="icon-<%=iconId%>">
                                                <%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with")%> <strong><%=Encode.forHtmlContent(idpDisplayName)%></strong>
                                            </button>
                                            <div class="ui flowing popup transition hidden isHubIdpPopup">
                                                <h5 class="font-large"><%=AuthenticationEndpointUtil.i18n(resourceBundle,"sign.in.with")%>
                                                    <%=Encode.forHtmlContent(idpDisplayName)%></h5>
                                                <div class="content">
                                                    <form class="ui form">
                                                        <div class="field">
                                                            <input id="domainName" class="form-control" type="text"
                                                                placeholder="<%=AuthenticationEndpointUtil.i18n(resourceBundle, "domain.name")%>">
                                                        </div>
                                                        <input type="button" class="ui button primary"
                                                            onClick="javascript: myFunction('<%=idpName%>','<%=idpEntry.getValue()%>','domainName')"
                                                            value="<%=AuthenticationEndpointUtil.i18n(resourceBundle,"go")%>"/>
                                                    </form>
                                                </div>
                                            </div>
                                        </div>
                                        <br>
                                    <%} else if (isGoogleIdp) { %>
                                       <div class="social-login blurring social-dimmer">
	                                        <div class="field">
	                                        	 <button type="button"
	                                        	         class="ui button"
	                                        	         data-testid="login-page-sign-in-with-google"
	                                        	         onclick="handleNoDomain(this,
			                                                    '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpName))%>',
			                                                    '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpEntry.getValue()))%>')"
	                                        	 >
									                <img class="ui image" src="libs/themes/asgardio/assets/images/identity-providers/google-idp-illustration.svg">
         								            <span><%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with")%> <%=Encode.forHtmlContent(idpDisplayName)%></span>
									            </button>
	                                        </div>
                                        </div>
                                        <br>
                                    <% } else if (isGitHubIdp) { %>
                                        <div class="social-login blurring social-dimmer">
                                            <div class="field">
                                                 <button type="button"
                                                         class="ui button"
                                                         data-testid="login-page-sign-in-with-github"
                                                         onclick="handleNoDomain(this,
                                                                '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpName))%>',
                                                                '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpEntry.getValue()))%>')"
                                                 >
                                                    <img class="ui image" src="libs/themes/asgardio/assets/images/identity-providers/github-idp-illustration.svg">
                                                    <span><%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with")%> <%=Encode.forHtmlContent(idpDisplayName)%></span>
                                                </button>
                                            </div>
                                        </div>
                                        <br>
                                    <% } else if (isFacebookIdp) { %>
                                        <div class="social-login blurring social-dimmer">
                                            <div class="field">
                                                 <button
                                                    type="button"
                                                    class="ui button"
                                                    data-testid="login-page-sign-in-with-facebook"
                                                    onclick="handleNoDomain(this,
                                                        '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpName))%>',
                                                        '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpEntry.getValue()))%>')"
                                                 >
                                                    <img class="ui image" src="libs/themes/asgardio/assets/images/identity-providers/facebook-idp-illustration.svg">
                                                    <span><%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with")%> <%=Encode.forHtmlContent(idpDisplayName)%></span>
                                                </button>
                                            </div>
                                        </div>
                                        <br>
                                    <% } else if (isMicrosoftIdp) { %>
                                     <div class="social-login blurring social-dimmer">
                                        <div class="field">
                                            <button
                                                 type="button"
                                                 class="ui button"
                                                 data-testid="login-page-sign-in-with-microsoft"
                                                 onclick="handleNoDomain(this,
                                                     '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpName))%>',
                                                     '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpEntry.getValue()))%>')"
                                            >
                                                 <img class="ui image" src="libs/themes/asgardio/assets/images/identity-providers/microsoft-idp-illustration.svg">
                                                 <span><%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with")%> <%=Encode.forHtmlContent(idpDisplayName)%></span>
                                            </button>
                                          </div>
                                        </div>
                                        <br>
                                     <% } else { %>
                                        <div class="social-login blurring social-dimmer">
                                            <div class="field">
                                                <button
                                                    id="icon-<%=iconId%>"
                                                    type="button"
                                                    class="ui button"
                                                    data-testid='login-page-sign-in-with-<%=Encode.forHtmlContent(idpName)%>'
                                                    onclick="handleNoDomain(this,
                                                        '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpName))%>',
                                                        '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpEntry.getValue()))%>')"
                                                    >
                                                        <img class="ui image" src="<%=Encode.forHtmlAttribute(imageURL)%>">
                                                        <span><%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with")%> <%=Encode.forHtmlContent(idpDisplayName)%></span>
                                                </button>
                                            </div>
                                        </div>
                                        <br>
                                    <% } %>
                                <% } else if (localAuthenticatorNames.size() > 0) {
                                    if (localAuthenticatorNames.contains(IWA_AUTHENTICATOR)) {
                                %>
                                <div class="field">
                                    <button class="ui blue labeled icon button fluid"
                                        onclick="handleNoDomain(this,
                                            '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpEntry.getKey()))%>',
                                            'IWAAuthenticator')"
                                        id="icon-<%=iconId%>"
                                        title="<%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with")%> IWA">
                                        <%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with")%> <strong>IWA</strong>
                                    </button>
                                </div>
                                <%
                                    }
                                    if (localAuthenticatorNames.contains(X509_CERTIFICATE_AUTHENTICATOR)) {
                                %>
                                <div class="field">
                                    <button class="ui grey labeled icon button fluid"
                                        onclick="handleNoDomain(this,
                                            '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpEntry.getKey()))%>',
                                            'x509CertificateAuthenticator')"
                                        id="icon-<%=iconId%>"
                                        title="<%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with")%> X509 Certificate">
                                        <i class="certificate icon"></i>
                                        <%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with")%> <strong>x509 Certificate</strong>
                                    </button>
                                </div>
                                <%
                                    }
                                    if (localAuthenticatorNames.contains(FIDO_AUTHENTICATOR)) {
                                %>
                                <div class="social-login blurring social-dimmer">
                                    <div class="field">
                                        <button class="ui button" onclick="handleNoDomain(this,
                                            '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpEntry.getKey()))%>',
                                            'FIDOAuthenticator')" id="icon-<%=iconId%>"
                                            title="<%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with")%>
                                                <%=AuthenticationEndpointUtil.i18n(resourceBundle, "fido.authenticator" )%>"
                                            data-componentid="login-page-sign-in-with-fido"
                                        >
                                            <img class="ui image" src="libs/themes/default/assets/images/icons/fingerprint.svg" alt="Fido Logo" />
                                            <span>
                                                <%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with" )%>
                                                <%=AuthenticationEndpointUtil.i18n(resourceBundle, "fido.authenticator" )%>
                                            </span>

                                        </button>
                                    </div>
                                </div>
                                <br />
                                <%
                                    }
                                        if (localAuthenticatorNames.contains(MAGIC_LINK_AUTHENTICATOR)) {
                                %>
                                <div class="social-login blurring social-dimmer">
                                    <div class="field">
                                        <button class="ui button" onclick="handleNoDomain(this,
                                            '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpEntry.getKey()))%>',
                                            '<%=MAGIC_LINK_AUTHENTICATOR%>')" id="icon-<%=iconId%>"
                                            title="<%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with")%>
                                                <%=AuthenticationEndpointUtil.i18n(resourceBundle, "magic.link" )%>"
                                            data-componentid="login-page-sign-in-with-magic-link">
                                            <img class="ui image" src="libs/themes/default/assets/images/icons/magic-link-icon.svg" alt="Magic Link Logo" />
                                            <span>
                                                <%=AuthenticationEndpointUtil.i18n(resourceBundle, "sign.in.with" )%>
                                                <%=AuthenticationEndpointUtil.i18n(resourceBundle, "magic.link" )%>
                                            </span>

                                        </button>
                                    </div>
                                </div>
                                <br />
                                <%
                                    }
                                    if (localAuthenticatorNames.contains("totp")) {
                                %>
                                 <div class="social-login blurring social-dimmer">
                                    <div class="field">
                                            <button
                                                type="button"
                                                id="icon-<%=iconId%>"
                                                class="ui button"
                                                data-testid="login-page-sign-in-with-totp"
                                                onclick="handleNoDomain(this,
                                                    '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpEntry.getKey()))%>',
                                                    'totp')"
                                            >
                                            <img class="ui image" src="libs/themes/default/assets/images/icons/outline-icons/clock-outline.svg">
                                            <span><%=AuthenticationEndpointUtil.i18n(resourceBundle, "totp.authenticator")%></span>
                                        </button>
                                    </div>
                                </div>
                                <br>
                                <%
                                    }
                                    if (localAuthenticatorNames.contains("sms-otp-authenticator")) {
                                %>
                                 <div class="social-login blurring social-dimmer">
                                    <div class="field">
                                            <button
                                                type="button"
                                                id="icon-<%=iconId%>"
                                                class="ui button"
                                                data-testid="login-page-sign-in-with-sms-otp-authenticator"
                                                onclick="handleNoDomain(this,
                                                    '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpEntry.getKey()))%>',
                                                    'sms-otp-authenticator')"
                                            >
                                            <img class="ui image" src="libs/themes/default/assets/images/icons/sms-icon.svg">
                                            <span><%=AuthenticationEndpointUtil.i18n(resourceBundle, "sms-otp-authenticator.authenticator")%></span>
                                        </button>
                                    </div>
                                </div>
                                <br>
                                <%
                                            }
                                    if (localAuthenticatorNames.contains("email-otp-authenticator")) {
                                %>
                                 <div class="social-login blurring social-dimmer">
                                    <div class="field">
                                            <button
                                                type="button"
                                                id="icon-<%=iconId%>"
                                                class="ui button"
                                                data-testid="login-page-sign-in-with-email-otp"
                                                onclick="handleNoDomain(this,
                                                        '<%=Encode.forJavaScriptAttribute(Encode.forUriComponent(idpEntry.getKey()))%>',
                                                        'email-otp-authenticator')"
                                            >
                                            <img class="ui image" src="libs/themes/default/assets/images/icons/solid-icons/email-solid.svg">
                                            <span><%=AuthenticationEndpointUtil.i18n(resourceBundle, "email.otp.authenticator")%></span>
                                        </button>
                                    </div>
                                </div>
                                <br>

                                <%
                                            }
                                        }

                                    }
                                } %>
                                </div>
                            </div>
                        <% }
                        String clientId = request.getParameter("client_id");
                        if ((StringUtils.equals("CONSOLE",clientId)
                             || (StringUtils.equals("MY_ACCOUNT",clientId)
                             && StringUtils.equals(tenantForTheming, IdentityManagementEndpointConstants.SUPER_TENANT)))
                             && !StringUtils.equals("true", promptAccountLinking)) {

                                String recoveryEPAvailable = application.getInitParameter("EnableRecoveryEndpoint");
                                String enableSelfSignUpEndpoint = application.getInitParameter("EnableSelfSignUpEndpoint");
                                Boolean isRecoveryEPAvailable = false;
                                Boolean isSelfSignUpEPAvailable = false;
                                String identityMgtEndpointContext = "";
                                String accountRegistrationEndpointURL = "";
                                String urlEncodedURL = "";
                                String urlParameters = "";

                                if (StringUtils.isNotBlank(recoveryEPAvailable)) {
                                    isRecoveryEPAvailable = Boolean.valueOf(recoveryEPAvailable);
                                } else {
                                    isRecoveryEPAvailable = isRecoveryEPAvailable();
                                }

                                if (StringUtils.isNotBlank(enableSelfSignUpEndpoint)) {
                                    isSelfSignUpEPAvailable = Boolean.valueOf(enableSelfSignUpEndpoint);
                                } else {
                                    isSelfSignUpEPAvailable = isSelfSignUpEPAvailable();
                                }

                                if (isRecoveryEPAvailable || isSelfSignUpEPAvailable) {
                                    if (StringUtils.equals("business-app", insightsAppIdentifier)) {
                                        String scheme = request.getScheme();
                                        String serverName = request.getServerName();
                                        int serverPort = request.getServerPort();
                                        String uri = (String) request.getAttribute(JAVAX_SERVLET_FORWARD_REQUEST_URI);
                                        String prmstr = (String) request.getAttribute(JAVAX_SERVLET_FORWARD_QUERY_STRING);
                                        String urlWithoutEncoding = scheme + "://" +serverName + ":" + serverPort + uri + "?" + prmstr;

                                        urlEncodedURL = URLEncoder.encode(urlWithoutEncoding, UTF_8);
                                        urlParameters = prmstr;


                                        identityMgtEndpointContext = application.getInitParameter("IdentityManagementEndpointContextURL");
                                        if (StringUtils.isBlank(identityMgtEndpointContext)) {
                                            try {
                                                identityMgtEndpointContext = ServiceURLBuilder.create().addPath(ACCOUNT_RECOVERY_ENDPOINT).build()
                                                        .getAbsolutePublicURL();
                                            } catch (URLBuilderException e) {
                                                request.setAttribute(STATUS, AuthenticationEndpointUtil.i18n(resourceBundle, CONFIGURATION_ERROR));
                                                request.setAttribute(STATUS_MSG, AuthenticationEndpointUtil
                                                        .i18n(resourceBundle, ERROR_WHILE_BUILDING_THE_ACCOUNT_RECOVERY_ENDPOINT_URL));
                                                request.getRequestDispatcher("error.do").forward(request, response);
                                                return;
                                            }
                                        }
                                    } else {
                                        urlParameters = "utm_source=" + insightsAppIdentifier;
                                    }

                                    accountRegistrationEndpointURL = application.getInitParameter("AccountRegisterEndpointURL");
                                    if (StringUtils.isBlank(accountRegistrationEndpointURL)) {
                                        accountRegistrationEndpointURL = identityMgtEndpointContext + ACCOUNT_RECOVERY_ENDPOINT_REGISTER;
                                    }
                                }
                            %>
                             <div class="mt-4">
                                    <div class="mt-3 external-link-container text-small">
                                        Don't have an account?
                                        <a
                                            onclick="handleSignupClick();window.location.href='<%=getRegistrationUrl(accountRegistrationEndpointURL, urlEncodedURL, urlParameters)%>';"
                                            target="_blank"
                                            class="clickable-link"
                                            rel="noopener noreferrer"
                                            data-testid="login-page-early-signup-link"
                                            style="cursor: pointer;"
                                        >
                                            Sign up
                                        </a>
                                    </div>
                             </div>
                        <% } %>
                    </div>
                </div>
            </div>
        </main>

        <!-- product-footer -->
        <%
            File productFooterFile = new File(getServletContext().getRealPath("extensions/product-footer.jsp"));
            if (productFooterFile.exists()) {
        %>
            <jsp:include page="extensions/product-footer.jsp"/>
        <% } else { %>
            <jsp:include page="includes/product-footer.jsp"/>
        <% } %>
    </div>

    <!-- footer -->
    <%
        File footerFile = new File(getServletContext().getRealPath("extensions/footer.jsp"));
        if (footerFile.exists()) {
    %>
        <jsp:include page="extensions/footer.jsp"/>
    <% } else { %>
        <jsp:include page="includes/footer.jsp"/>
    <% } %>

    <script src="util/string-utils.js"></script>

    <script>

        var passwordField = $("#password");
        var usernameField = $("#usernameUserInput");

        var insightsAppIdentifier = "<%=insightsAppIdentifier%>";
        var insightsTenantIdentifier = "<%=insightsTenantIdentifier%>";

        function checkSessionKey() {
            $.ajax({
                type: "GET",
                url: "<%= Encode.forJavaScriptBlock(loginContextRequestUrl)%>",
                xhrFields: { withCredentials: true },
                success: function (data) {
                    if (data && data.status == 'redirect' && data.redirectUrl && data.redirectUrl.length > 0) {
                        window.location.href = data.redirectUrl;
                    }
                },
                cache: false
            });
        }

        // show password function
        function showPassword() {
            if (passwordField.attr("type") === 'text') {
                passwordField.attr("type", "password")
                document.getElementById("password-eye").classList.add("slash");
            } else {
                passwordField.attr("type", "text")
                document.getElementById("password-eye").classList.remove("slash");
            }
        }

        function getParameterByName(name, url) {
            if (!url) {
                url = window.location.href;
            }
            name = name.replace(/[\[\]]/g, '\\$&');
            var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)'),
            results = regex.exec(url);
            if (!results) return null;
            if (!results[2]) return "";
            return decodeURIComponent(results[2].replace(/\+/g, ' '));
        }

        $(document).ready(function () {
            var label = $("#user-name-label");
            var NATIVE_ELEMENT = 0;
            /**
             * Below condition will trigger the label popup based on the
             * text overflown property. Basically, if the text is overflown
             * we will attach the popup to the label. Otherwise we don't.
             *
             * Note that we are immediately evaluating this expression on
             * document ready state. This is because, when the user gets to
             * this page the email address / username is uneditable and is
             * represented in a label format. So, we don't need to periodically
             * check the label length changes.
             *
             * {@code NATIVE_ELEMENT} is used to access the native element
             * of the queried jquery element. There's a another variant called
             * $.get(index) but it is slow compared to computed index access.
             */
            if (label && label[NATIVE_ELEMENT]) {
                if (label[NATIVE_ELEMENT].offsetWidth < label[NATIVE_ELEMENT].scrollWidth)
                    label.popup({lastResort: "top left"});
            }

            $('.main-link').click(function () {
                $('.main-link').next().hide();
                $(this).next().toggle('fast');
                var w = $(document).width();
                var h = $(document).height();
                $('.overlay').css("width", w + "px").css("height", h + "px").show();
            });

            $('.overlay').click(function () {
                $(this).hide();
                $('.main-link').next().hide();
            });

            $('.ui.dimmer').dimmer({
                on: 'hover',
                duration : {
                    show : 500,
                    hide : 500
                }
            });

            <%
                if(reCaptchaEnabled) {
            %>
                var error_msg = $("#error-msg");

                $("#loginForm").submit(function (e) {
                    var resp = $("[name='g-recaptcha-response']")[0].value;
                    if (resp.trim() == '') {
                        error_msg.text("<%=AuthenticationEndpointUtil.i18n(resourceBundle,"please.select.recaptcha")%>");
                        error_msg.show();
                        $("html, body").animate({scrollTop: error_msg.offset().top}, 'slow');
                        return false;
                    }
                    return true;
                });
            <%
                }
            %>

            passwordField.focusin();
            usernameField.focusin();
        });

        function myFunction(key, value, name) {
            var object = document.getElementById(name);
            var domain = object.value;


            if (domain != "") {
                document.location = "<%=commonauthURL%>?idp=" + key + "&authenticator=" + value +
                        "&sessionDataKey=<%=Encode.forUriComponent(request.getParameter("sessionDataKey"))%>&domain=" +
                        domain;
            } else {
                document.location = "<%=commonauthURL%>?idp=" + key + "&authenticator=" + value +
                        "&sessionDataKey=<%=Encode.forUriComponent(request.getParameter("sessionDataKey"))%>";
            }
        }

        function handleNoDomain(elem, key, value) {
            var linkClicked = "link-clicked";
            if ($(elem).hasClass(linkClicked)) {
                console.warn("Preventing multi click.")
            } else {
                AppInsights.getInstance().trackEvent("authentication-portal-click-sign-in-with", {
                    "type": StringUtils.kebabCase(value),
                    "app": insightsAppIdentifier,
                    "tenant": insightsTenantIdentifier !== "null" ? insightsTenantIdentifier : ""
                });

                $(elem).addClass(linkClicked);
                document.location = "<%=commonauthURL%>?idp=" + key + "&authenticator=" + value +
                    "&sessionDataKey=<%=Encode.forUriComponent(request.getParameter("sessionDataKey"))%>" +
                    "<%=multiOptionURIParam%>";
            }
        }

        window.onunload = function(){};

        function changeUsername (e) {
            document.getElementById("changeUserForm").submit();
        }

        $('.isHubIdpPopupButton').popup({
            popup: '.isHubIdpPopup',
            on: 'click',
            position: 'top left',
            delay: {
                show: 300,
                hide: 800
            }
        });

        function handleSignupClick() {
            AppInsights.getInstance().trackEvent("authentication-portal-click-signup", {
                "app": insightsAppIdentifier,
                "tenant": insightsTenantIdentifier !== "null" ? insightsTenantIdentifier : ""
            });
        }
    </script>

    <%!
        private boolean isIdentifierFirstLogin(String inputType) {
            return "idf".equalsIgnoreCase(inputType);
        }
    %>
</body>
</html>
